#include <Arduino.h>
#include <U8g2lib.h>
#include "FM1216.h"


#ifdef U8X8_HAVE_HW_SPI
#include <SPI.h>
#endif
#ifdef U8X8_HAVE_HW_I2C
#include <Wire.h>
#endif

const int pin_A = 3;  // pin 3
const int pin_B = 2;  // pin 2
const int buttonPin = 4;
int buttonState = 0;
int_fast32_t step1 = 100;
unsigned char encoder_A;
unsigned char encoder_B;
unsigned char encoder_A_prev = 0;
unsigned long frq = 127800;
unsigned long frq_old;
unsigned long currentTime;
unsigned long loopTime;
float frq_disp;
int  stp = 1;
int  stp_old;
unsigned long butTime = 0;


U8G2_ST7565_64128N_F_4W_HW_SPI u8g2(U8G2_R0, /* cs=*/ 10, /* dc=*/ 9, /* reset=*/ 8);

FM1216 tuner;

void setup(void) {
  u8g2.begin();
  pinMode(buttonPin, INPUT);
  loopTime = currentTime;
  tuner.init();
  tuner.setFreq(frq);
  tuner.setStereo(true);
}

void loop(void) {

  unsigned long currentButTime = millis();
  if (currentButTime >= (butTime + 50)) {
      int but = digitalRead(buttonPin);
      if (buttonState != but) {
        buttonState = but;
        if (buttonState == LOW) {
          switch (stp) {
            case 0:
              stp = 1;
              step1 = 100;
               u8g2.firstPage();
               do {
               u8g2.setFont(u8g2_font_ncenB14_te);
               u8g2.setCursor(38, 20);
               u8g2.print("Step");
               u8g2.setCursor(25, 50);
               u8g2.print("100 KHz");
                 } while ( u8g2.nextPage() );
              break;
            case 1:
              stp = 0;
              step1 = 1000;
               u8g2.firstPage();
                do {
               u8g2.setFont(u8g2_font_ncenB14_te);
               u8g2.setCursor(38, 20);
               u8g2.print("Step");
               u8g2.setCursor(29, 50);
               u8g2.print("1 MHz");
                 } while ( u8g2.nextPage() );
              break;
            default:
              stp = 0;
          }
        }
      }
    butTime = currentButTime;
  }
  rotary_enc();

  if (frq != frq_old)
  {

    u8g2.firstPage();
    do {
      frq_disp = frq;
      frq_disp = ((frq_disp / 1000) - 22.6);
      tuner.setFreq(frq);
      u8g2.setFont(u8g2_font_ncenB14_te);
      u8g2.setCursor(18, 20);
      u8g2.print("FM Radio");
      u8g2.setCursor(8, 50);
      u8g2.print(frq_disp, 2);
      u8g2.print(" MHz");
    } while ( u8g2.nextPage() );
    frq_old = frq;
  }
}



void rotary_enc()
{
  currentTime = millis();
  if (currentTime >= (loopTime + 5)) {
    encoder_A = digitalRead(pin_A);
    encoder_B = digitalRead(pin_B);
    if ((!encoder_A) && (encoder_A_prev)) {
      if (encoder_B) {
        frq = frq + step1;
        if (frq > 130600) {
          frq = 87600;
        }
      }
      else {
        frq = frq - step1;
        if (frq < 87600) {
          frq = 130600;
        }
      }
    }
    encoder_A_prev = encoder_A;
    loopTime = currentTime;
  }
}


